=== debian/changelog ===
metview (5.7.2.1-2) unstable; urgency=medium

  * Fix for FTBFS on 32-bit systems - mir-32bit.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Nov 2019 16:18:57 +0000

metview (5.7.2.1-1) unstable; urgency=medium

  * New upstream release
  * Add missing build-depends: libxxhash-dev, libsnappy-dev, liblz4-dev,
      libbz2-dev. Closes: #945096
  * Drop ACCEPT_USE_OF_DEPRECATED_PROJ_API_H no longer needed
  * Build and include libmir and components

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Nov 2019 15:00:45 +0000
